//$Id: Utils.js,v 1.20.2.3 2005/06/16 09:37:06 shanmugampl Exp $

// ------------------- General Object related methods ---------------------- //

/**
 * Retruns the x position of the given object in the window / screen.
 */
function findPosX(obj) {
	var curleft = 0;
	if (document.getElementById || document.all) {
		while (obj.offsetParent) {
			curleft += obj.offsetLeft;
			obj = obj.offsetParent;
		}
	} 
	else if (document.layers) {
		curleft += obj.x;
	}
	return curleft;
}

/**
 * Retruns the x position of the given object in the window / screen.
 */
function findPosY(obj) {
	var curtop = 0;
	if (document.getElementById || document.all) {
		while (obj.offsetParent) {
			curtop += obj.offsetTop;
			obj = obj.offsetParent;
		}
	} else if (document.layers) {
		curtop += obj.y;
	}
	return curtop;
}

/**
 * Retruns the object for the given element id and document object.
 */
function getObj(n,d) {
	var p,i,x; 
	if(!d)
		d=document;

	if((p=n.indexOf("?"))>0&&parent.frames.length) {
		d=parent.frames[n.substring(p+1)].document; n=n.substring(0,p);
	}

	if(!(x=d[n])&&d.all){
		x=d.all[n];
	}

	for(i=0;!x&&i<d.forms.length;i++){
		x=d.forms[i][n];
	}

	for(i=0;!x&&d.layers&&i<d.layers.length;i++){
		x=getObj(n,d.layers[i].document);
	}

	if(!x && d.getElementById){
		x=d.getElementById(n);
	}
	return x;
}

function reloadAndCloseWindow(additionalParamsToPass)
{
    if(self.parent.window.opener != null)
    {
     	self.parent.window.opener.addRequestParams(self.parent.window.opener.ROOT_VIEW_ID, additionalParamsToPass);
        self.parent.window.opener.refreshCurrentView();
    }
   self.parent.window.close();
}

function enableCustomization(){
	var previousData = stateData[ROOT_VIEW_ID]["_D_RP"];
	if(previousData != null){
		stateData[ROOT_VIEW_ID]["_D_RP"] = previousData + "PERSONALIZE=TRUE";
	}
	else {
	stateData[ROOT_VIEW_ID]["_D_RP"] = "PERSONALIZE=TRUE";
	}
	refreshCurrentView();
}

function enableViewMode(){
	var previousData = stateData[ROOT_VIEW_ID]["_D_RP"];
	if(previousData != null){
		stateData[ROOT_VIEW_ID]["_D_RP"] = previousData + "PERSONALIZE=FALSE";
	}
	else {
	stateData[ROOT_VIEW_ID]["_D_RP"] = "PERSONALIZE=FALSE";
	}
	refreshCurrentView();
}

function showBorder(elementId){
	element = document.getElementById(elementId + "_Border");
	element.className = 'showDivBorder';
}
function hideBorder(elementId){
	element = document.getElementById(elementId + "_Border");
	element.className = 'divBorder';
}

function searchViews(searchObject){
	document.getElementById('views').className = 'show';
	return updateSearchData('ListViewConfigurations', searchObject);
}

function expandCollapse(elemId, imgID){
	var ids = new Array('srcImg', 'rmImg', 'avlImg');
	var tabs = new Array('_SearchTab', '_RmTab', '_AvlTab');
	for(var i = 0; i < tabs.length; i++){
		currId = tabs[i];
		if(currId == elemId){
			if(document.getElementById(elemId).className == 'show'){
				document.getElementById(elemId).className = 'hide';
				document.getElementById(imgID).className = 'collapse';
				document.getElementById('views').className = 'hide';
			}
			else {
				document.getElementById(elemId).className = 'show';
				document.getElementById(imgID).className = 'expand';
				if(currId == '_SearchTab'){
					document.getElementById('views').className = 'hide';
					document.getElementById('orgTab1').className = 'hide';
					document.getElementById('orgTab2').className = 'hide';
					document.getElementById('dummyTab1').className = 'show';
					document.getElementById('dummyTab2').className = 'show';
				}
				if(currId == '_AvlTab'){
					document.getElementById('views').className = 'show';
					document.getElementById('orgTab1').className = 'show';
					document.getElementById('orgTab2').className = 'show';
					document.getElementById('dummyTab1').className = 'hide';
					document.getElementById('dummyTab2').className = 'hide';
					updateSearchData('ListViewConfigurations', document.getElementById('groupSearch'));
				}
				if(currId == '_RmTab'){
					document.getElementById('views').className = 'hide';
					document.getElementById('orgTab1').className = 'show';
					document.getElementById('orgTab2').className = 'show';
					document.getElementById('dummyTab1').className = 'hide';
					document.getElementById('dummyTab2').className = 'hide';

				}
			}
		}
		else {
			document.getElementById(currId).className = 'hide';
			document.getElementById(ids[i]).className = "collapse";
		}
	}
}

function enableForm(formName){
	document.getElementById(formName + "ReadMode").className = 'hide';
	document.getElementById(formName + "EditMode").className = 'show';
}

var customize_uniqueId = null;
/**
 *
 */
function showCustomizeLinks(linksId, id, event,referenceId){
	customize_uniqueId = referenceIds[referenceId];
	linksId = linksId + referenceId;
	getObj(linksId).style.display="block";
	getObj(linksId).style.left=findPosX(getObj(id));
	getObj(linksId).style.top=findPosY(getObj(id))+getObj(id).offsetHeight;
}

/**
 *
 */
function hideCustomizationMenu(ev)
{
	// TODO:
	// This is not the way for healthy coding. The links to be removed have
	// been hardcoded. This is because, hiding takes place on click of the
	// body. Two events cannot be fired from there.Hence  the hardcoding.
	// Something needs to be done.
	if (browser_ie){
		currElement=window.event.srcElement;
	}
	else if (browser_nn4 || browser_nn6){
		currElement=ev.target;
	}
	var id = currElement.id;
	if(id.indexOf("ICM") < 0 && customize_uniqueId != null){
		var refId = stateData[customize_uniqueId]["ID"];
		var element = document.getElementById("GridCustomizationLinks" + refId);
		if(element != null){
			if (getObj("GridCustomizationLinks" + refId).style.display=="block"){
				getObj("GridCustomizationLinks" + refId).style.display="none";
			}
		}
		element = document.getElementById("TabCustomizationLinks" + refId);
		if(element != null){
			if (getObj("TabCustomizationLinks" + refId).style.display=="block"){
				getObj("TabCustomizationLinks" + refId).style.display="none";
			}
		}

	}
}


/*
 *
 */
function openCustomizationWindow(url, params){
	url = url + "&UNIQUEID=" + customize_uniqueId;
	window.open(url, customize_uniqueId, params);
}

function openCW(url, type, refId, reqParams, winParams){
	var uId = referenceIds[refId];
	var vName = stateData[uID]["_VN"];
	url = url + "?CUSTOMIZEVIEW=" + vName + "&UNIQUEID=" + uId;
	if(type != null){
		url = ul + "&TYPE=" + type;
	}
	if(reqParams != null){
		url = url + "&" + reqParams;
	}
	window.open(url, uId, winParams);
}


function popWindow(url,name,x,y,isResizable)
{

 // To pop upa new window with the given url and dimensions
 var posX = (screen.width/2)-(x/2);
 var posY = (screen.height/2)-(y/2);
 var winPref = "width=" + x + ",height=" + y
  + ",innerWidth=" + x + ",innerHeight=" + y
  + ",left=" + posX + ",top=" + posY
  + ",screenX=" + posX + ",screenY=" + posY
  + ",toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=yes,"
  + "resizable="+isResizable;
  
 var newWin = window.open(url,name,winPref);
 
 if (window.focus)
 {
  newWin.focus();
 }
 
}

/**
 * Transfers the content from the source mesage holder to the destination
 * message holder which are represented by the srcMessageDiv and
 * destMessageDiv. Also by default it sets the scroll bars back to their
 * original position of [0,0]. This can de disabled by setting the initScroll
 * to false.
 *
 * @param	srcMessageDiv		the source message div id.
 * @param	destMessageDiv	the destination message div id.
 * @param	initScroll			true to reset scroll position, false to leave is as such.
 */
function addContentToMessageDiv(srcMessageDiv, destMessageDiv, initScroll){
	var srcObj = document.getElementById(srcMessageDiv);
	var destObj = document.getElementById(destMessageDiv);
	if(srcObj != null && destObj != null){
		destObj.innerHTML = srcObj.innerHTML;
	}
	if(initScroll == null || initScroll){
		document.body.scrollTop = 0;
		document.body.scrollLeft = 0;
	}
}

function isCookieEnabled(){
	var isCookieEnabled = true;
	if(document.cookie == ""){
		document.cookie = "AcceptsCookiesCheck=yes";
		if(document.cookie.indexOf('AcceptsCookiesCheck=yes') == -1){
			isCookieEnabled = false;
		}
	}
	// This line is not required. Need to confirm this and remove
	document.cookie = "";
	return isCookieEnabled;
}

function isBrowserSupported()
{
	var agt=navigator.userAgent.toLowerCase();
	this.major = parseInt(navigator.appVersion);
	this.minor = parseFloat(navigator.appVersion);

	this.nav  = ((agt.indexOf('mozilla')!=-1) && (agt.indexOf('spoofer')==-1)
			&& (agt.indexOf('compatible') == -1) && (agt.indexOf('opera')==-1)
			&& (agt.indexOf('webtv')==-1));
	this.nav5up = (this.nav && (this.major >= 5));

	this.ie   = (agt.indexOf("msie") != -1);
	this.ie5up  = (this.ie && (this.major == 4) && (agt.indexOf("msie 6.0")> 0) );
	this.opera = (agt.indexOf("opera") != -1);
	if((this.nav5up || this.ie5up) && !this.opera){
		return true;
	}
	else {
		return false;
	}
}

